<script setup lang="ts">
import { ref } from "vue";
import { LIcon, LMarker } from "@vue-leaflet/vue-leaflet";
import Intervention from "../../../types/intervention";

definePageMeta({
  middleware: "authentication",
});

const { baseURL } = useRuntimeConfig().app;
const { id } = useRoute().params;
const authorizationHeader = useAuthorizationHeader("application/json");
const patchAuthorizationHeader = useAuthorizationHeader(
  "application/merge-patch+json"
);

const { data: intervention } = await useFetch<Intervention>(
  baseURL + "api/interventions/" + id,
  {
    headers: authorizationHeader,
  }
);

let showModal = ref(false);

async function changeStatus(id: number) {
  try {
    const response = await fetch(`${baseURL}api/interventions/${id}`, {
      method: "PATCH",
      headers: patchAuthorizationHeader,
      body: JSON.stringify({
        status: `/status/in-progress`,
      }),
    });
    window.location.href = `/interventions/${id}/encours`;
    // Traiter la réponse si nécessaire
  } catch (error) {
    console.error(error);
  }
}
</script>

<template>
  <SubHeader>
    <h1 class="fr-p-4v">Intervention - #{{ id }}</h1>
  </SubHeader>

  <Stepper
    :current="1"
    :last="3"
    :labels="['À faire', 'En cours', 'Terminé']"
  />

  <InterventionDetails>
    <div slot="carte">
      <Map
        :lat-lng="[
          intervention.location.latitude,
          intervention.location.longitude,
        ]"
        :zoom="20"
        class="map"
      >
        <LMarker
          :lat-lng="[
            intervention.location.latitude,
            intervention.location.longitude,
          ]"
        >
        <LIcon :icon-url="usePinPicture(intervention.priority.slug)" />
        </LMarker>
      </Map>
    </div>
  </InterventionDetails>

  <button class="fr-btn fr-grid-row--center" @click="showModal = true">
    Commencer l'intervention
  </button>

  <Modal :show="showModal" @close="showModal = false">
    <div class="fr-mx-2w">
      <h2 class="fr-icon-arrow-right-line">Êtes-vous sûr ?</h2>

      <p class="fr-pb-2w">
        Vous vous apprêtez à commencer l’intervention “{{
          intervention.type.name
        }}”
      </p>
    </div>

    <ul class="fr-btns-group fr-mx-2w">
      <li>
        <button
          class="fr-btn fr-grid-row--center"
          @click.prevent="changeStatus(id)"
        >
          Commencer l'intervention
        </button>
      </li>

      <li>
        <button
          class="fr-btn fr-btn--secondary fr-grid-row--center"
          @click="showModal = false"
        >
          Annuler
        </button>
      </li>
    </ul>
  </Modal>
</template>

<style scoped>
button {
  width: 100%;
  position: sticky;
  bottom: 0;
}
.map {
  height: 25rem;
}
</style>
